#include <bits/stdc++.h>
using namespace std;

int main(){
    int N,Q,x,y,temp,dmg=0;   cin >> N >> Q;
    vector<int> D; vector<int> P; vector<int> H; vector<int> resenja;
    bool P0 = true;
    for(int i=0; i<N; i++){
        cin >> x >> y;
        if(y != 0){
            P0 = false;
        }
        dmg+=x;
        D.push_back(x);
        P.push_back(y);
    }
    for(int i=0; i<Q; i++){
        cin >> x;
        H.push_back(x);
    }

    for(int i=0; i<Q; i++){
            if(P0 == true){
                if(dmg < H[i]){
                    resenja.push_back(-1);
                }else{
                    int ctr=0;
                    int ctr2 = 0;
                    while(H[i]>0){
                        H[i] -= D[ctr2];
                        ctr++;
                        ctr2++;
                    }
                    resenja.push_back(ctr);
                }
            }
    }





    for(auto x: resenja){
        cout << x << endl;
    }
}